   --  襭    譥 
   -- *********************************************************
   import Tree
   ------------------------------------------------------
   -- ।, ⠭騩 稥   設 a
   --  設 b ୮ ॢ ᪠ tree
   --------------------------------------------
   way_AB:: Int -> Int -> BTree -> Bool
   way_AB a b tree =   search a (search b tree)/=nil
                    || search b (search a tree)/=nil
   --------------------------------------------------------
   -- 㭪,       
   -- 設 a  ୮ ॢ ᪠ tree
   ------------------------------------------
   lenWay:: Int -> BTree -> Int
   lenWay a tree | isEmpty tree || root tree==a 
                               = 0
                 | a<root tree = 1 + lenWay a (left tree)
                 | True        = 1 + lenWay a (right tree)
   -------------------------------------------------------
   -- 㭪,      ୮
   -- ॢ ᪠
   -----------------------------------
   allWays:: BTree -> BTree -> [[Int]]
   allWays tree tree1 
          | isEmpty tree = []
          | True         =   allWays (left tree) tree1
                          ++ [waySearch (root tree) tree1]
                          ++ allWays (right tree) tree1
   ----------------------------------------------------
   -- 㭪,     設
   --  ୮ ॢ ᪠
   ---------------------------------
   waySearch:: Int -> BTree -> [Int]
   waySearch a Nil = []
   waySearch a (Node x l r) | a==x = [x]
                            | a<x  = [x] ++ waySearch a l
                            | True = [x] ++ waySearch a r
   ------------------------------------------------------
   -- 㭪 頥 쭮 ﭨ   
   -- ୮ ॢ ᪠ Tree  쥢
   ------------------------------------------
   abc:: BTree -> Int
   abc tree | isEmpty (left tree) && isEmpty (right tree) 
                                   = 0
            | isEmpty (left tree)  = 1 + abc (right tree)
            | isEmpty (right tree) = 1 + abc (left tree)
            | True                 = min (1 + abc (left tree))
                                         (1 + abc (right tree))
   ------------------------------------------------------------
   -- 㭪 頥 ""   設 x
   -- ୮ ॢ ᪠ tree
   -------------------------------
   srchFath':: Int -> BTree -> Int
   srchFath' x tree = last (init (waySearch x tree))
   -------------------------------------------------
   -- 㭪,   ७ 
   --  ୮ ॢ ᪠ Tree.
   --
   --   ७  =
   --    0, ᫨ ॢ ;
   --    -1 + ⢮ 㧫  ॢ
   --       +  ७   ॢ
   --       +  ७  ࠢ ॢ
   ----------------------------------------------------
   interWay:: BTree -> Int
   interWay tree | isEmpty (tree) = 0
                 | True           = -1 + length (klpObh tree)
                                       + interWay (left tree)
                                       + interWay (right tree)
   -- ********************************************************
   -- 㤠 ⮢ ਬ:
   ----------------------------------------
   test = testWay_AB && testLenWay && test1
   -----------------------------------------------------
   testWay_AB =   way_AB 1 2 (Node 1 (Node (-1) Nil Nil)
                                     (Node 2 Nil Nil))
                         == True
               && way_AB 10 22 
                   (Node 8 (Node 6 (Node 1 Nil Nil) Nil)
                           (Node 10 Nil (Node 14 (Node 12 Nil Nil)
                                                 (Node 22 Nil Nil))))
                         == True

               && way_AB 2 5 (Node 3 (Node 5 Nil Nil)
                                     (Node 4 Nil Nil))
                         == False
               && way_AB 2 7 (Node 4 (Node 2 Nil Nil)
                                     (Node 6 (Node 5 Nil Nil)
                                             (Node 7 Nil Nil)))
                         == False
               && way_AB 3 7 (Node 4 (Node 2 Nil (Node 3 Nil Nil))
                                     (Node 6 (Node 5 Nil Nil)
                                             (Node 7 Nil Nil)))
                         == False
   -------------------------------------------------------
   testLenWay =   lenWay 3 (list 3)                   == 0
               && lenWay 3 (node 5 (list 3) 
                                   (list 4))          == 1
               && lenWay 5 (node 4 (node 2 nil (list 3)) 
                                   (node 6 (list 5) 
                                           (list 7))) == 2
               && lenWay 7 (node 4 (node 2 nil (list 3)) 
                                   (node 6 (list 5) 
                                           (list 7))) == 2
               && lenWay 3
                   (node 9 (node 6 (list 3)
                                   (node 7 nil (list 8))) 
                           (node 15 (list 12) 
                                    (node 18 (list 17)
                                             nil)))   == 2
   -----------------------------------------------------------
   test1 =    interWay (Node 3 Nil Nil)                   == 0
           && interWay (Node 3 (Node 5 Nil Nil)
                               (Node 4 Nil Nil))          == 2
           && interWay (Node 4 (Node 2 Nil (Node 3 Nil Nil))
                               (Node 6 (Node 5 Nil Nil)
                                       (Node 7 Nil Nil))) == 8
           && interWay (Node 10 (Node 6 (Node 3 Nil Nil)
                                        (Node 7 Nil
                                                (Node 8 Nil Nil)))
                                (Node 15 (Node 12 Nil Nil)
                                         (Node 18 (Node 17 Nil Nil)
                                                  Nil)))  == 16
   ------------------------------------------------------------
   tree = node 10 (node 6 (list 3)
                          (node 7 nil (list 8)))
                  (node 15 (list 12) 
                           (node 18 (list 17) nil))
   tree1 = node 10 (node 6 (list (-27)) 
                           (node 7 nil (list 8))) 
                   (node 15 (list 12) 
                            (node 18 (list 17) nil))
   -------------------------------------------------
   test2 = waySearch 8 tree
   test3 = allWays tree tree
   test4 = srchFath' 3 (node 4 (list 3) (list 5))         == 4
        && srchFath' 5 (Node 4 (Node 3 Nil Nil)
                               (Node 5 Nil Nil))          == 4
        && srchFath' 5 (Node 4 (Node 2 Nil (Node 3 Nil Nil))
                               (Node 6 (Node 5 Nil Nil)
                                       (Node 7 Nil Nil))) == 6
        && srchFath' 6 (Node 4 (Node 2 Nil (Node 3 Nil Nil))
                               (Node 6 (Node 5 Nil Nil)
                                       (Node 7 Nil Nil))) == 4
        && srchFath' 17 (Node 10 (Node 6 (Node 3 Nil Nil)
                                         (Node 7 Nil
                                                 (Node 8 Nil Nil)))
                                 (Node 15 (Node 12 Nil Nil)
                                          (Node 18 (Node 17 Nil Nil)
                                                   Nil))) == 18
        && srchFath' 7 (Node 10 (Node 6 (Node 3 Nil Nil)
                                        (Node 7 Nil
                                                (Node 8 Nil Nil)))
                                (Node 15 (Node 12 Nil Nil)
                                         (Node 18 (Node 17 Nil Nil)
                                                  Nil)))  == 6
   -----------------------------------------------------------
   test5 = abc tree
   test6 = abc tree1
